using VetClinicContracts.ViewModels;
using Newtonsoft.Json;
using System.Net.Http.Headers;
using System.Text;

namespace VetClinicAdminApp
{
    public class APIAdmin
    {
        private static readonly HttpClient _admin = new();

        public static AdminViewModel? Admin { get; set; } = null;

        public static void Connect(IConfiguration configuration)
        {
            _admin.BaseAddress = new Uri(configuration["IPAddress"]);
            _admin.DefaultRequestHeaders.Accept.Clear();
            _admin.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
        }

        public static T? GetRequest<T>(string requestUrl)
        {
            var response = _admin.GetAsync(requestUrl);
            var result = response.Result.Content.ReadAsStringAsync().Result;

            if (response.Result.IsSuccessStatusCode)
            {
                return JsonConvert.DeserializeObject<T>(result);
            }
            else
            {
                throw new Exception(result);
            }
        }

        public static void PostRequest<T>(string requestUrl, T model)
        {
			var json = JsonConvert.SerializeObject(model);
			var data = new StringContent(json, Encoding.UTF8, "application/json");

			var response = _admin.PostAsync(requestUrl, data);

			var result = response.Result.Content.ReadAsStringAsync().Result;

			if (!response.Result.IsSuccessStatusCode)
			{
				throw new Exception(result);
			}
		}
    }
}
